% Esercizio 5
clear all
close all
clc

luerr = [];
ndim = [];
xerr = [];
for n=2:20,
    A = hilb(n);
    xsol = ones(n,1);
    b = A*xsol;
    % fattorizzazione LU
    [L,U,P] = lu(A);
    % soluzione
    x = U\(L\(P*b))
    % errori
    luerr = [luerr,norm(P*A-L*U,Inf)];
    ndim = [ndim,n];
    xerr = [xerr,norm(x-xsol)/norm(xsol)];
end

figure;
h = semilogy(ndim,luerr);
set(h,'LineWidth',2);
xlabel('n');
title('err. fatt. lu');

figure;
h = semilogy(ndim,xerr);
set(h,'LineWidth',2);
xlabel('n');
title('err. su soluzione');
