function L=cholesky(A)
% Fattorizzazione di Cholesky

[m,n] = size(A);

% Inizializzazione di L
L = zeros(size(A));

L(1,1) = sqrt(A(1,1));
for i=2:n
    % calcolo r
    r = sost_avanti(L(1:(i-1),1:(i-1)),A(1:(i-1),i));
    
    % calcolo beta
    beta = sqrt(A(i,i)-r'*r);
    
    % salvo i valori in L
    L(i,1:(i-1)) = r;
    L(i,i) = beta;
end

